using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;

namespace SAVEApplication
{
	/// <summary>
	/// Summary description for Form2.
	/// </summary>
	public class Form2 : System.Windows.Forms.Form
	{
		Info myInfo = new Info();
		ArrayList mousepath = new ArrayList();
		ArrayList vectorpath = new ArrayList();

		ArrayList vectortime = new ArrayList();
		ArrayList cleararray = new ArrayList();

		int lastClearMouse = 0;
		int lastClearVector = 0;

		DateTime starttime;

		private int counter = 0;
		private int rate = 3;
		Pen myPen = new System.Drawing.Pen(System.Drawing.Brushes.DarkRed,1.0f);
		private bool isDrawing = false;
		private bool isRecording = false;
		private System.Windows.Forms.Button Clear;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button SaveButton;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Button RecordButton;
		private System.Windows.Forms.Button Info;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form2()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			cleararray.Add( new Point(-1,-1));

			this.panel1.Left = 0;
			this.panel1.Width = this.Width / 2 - 2;
			this.panel2.Left = this.Width / 2;
			this.panel2.Width = this.Width/2 - 2;

			starttime = DateTime.Now;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
				myPen.Dispose();
				myInfo.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form2));
			this.Clear = new System.Windows.Forms.Button();
			this.panel2 = new System.Windows.Forms.Panel();
			this.panel1 = new System.Windows.Forms.Panel();
			this.SaveButton = new System.Windows.Forms.Button();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.RecordButton = new System.Windows.Forms.Button();
			this.Info = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// Clear
			// 
			this.Clear.Image = ((System.Drawing.Image)(resources.GetObject("Clear.Image")));
			this.Clear.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
			this.Clear.Location = new System.Drawing.Point(224, 8);
			this.Clear.Name = "Clear";
			this.Clear.Size = new System.Drawing.Size(75, 75);
			this.Clear.TabIndex = 6;
			this.Clear.Text = "Clear";
			this.Clear.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			this.Clear.Click += new System.EventHandler(this.Clear_Click);
			// 
			// panel2
			// 
			this.panel2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
			this.panel2.BackColor = System.Drawing.SystemColors.ControlDark;
			this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel2.Location = new System.Drawing.Point(280, 96);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(248, 448);
			this.panel2.TabIndex = 5;
			this.panel2.Paint += new System.Windows.Forms.PaintEventHandler(this.panel2_Paint);
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
			this.panel1.BackColor = System.Drawing.SystemColors.ControlDark;
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel1.Location = new System.Drawing.Point(40, 96);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(248, 448);
			this.panel1.TabIndex = 4;
			this.panel1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseUp);
			this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
			this.panel1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseMove);
			this.panel1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseDown);
			// 
			// SaveButton
			// 
			this.SaveButton.Image = ((System.Drawing.Image)(resources.GetObject("SaveButton.Image")));
			this.SaveButton.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
			this.SaveButton.Location = new System.Drawing.Point(136, 8);
			this.SaveButton.Name = "SaveButton";
			this.SaveButton.Size = new System.Drawing.Size(75, 75);
			this.SaveButton.TabIndex = 7;
			this.SaveButton.Text = "Save";
			this.SaveButton.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			this.SaveButton.Click += new System.EventHandler(this.SaveButton_Click);
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.Filter = "SAVE files|*.sav";
			// 
			// RecordButton
			// 
			this.RecordButton.Image = ((System.Drawing.Image)(resources.GetObject("RecordButton.Image")));
			this.RecordButton.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
			this.RecordButton.Location = new System.Drawing.Point(48, 8);
			this.RecordButton.Name = "RecordButton";
			this.RecordButton.Size = new System.Drawing.Size(75, 75);
			this.RecordButton.TabIndex = 8;
			this.RecordButton.Text = "Record";
			this.RecordButton.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			this.RecordButton.Click += new System.EventHandler(this.RecordButton_Click);
			// 
			// Info
			// 
			this.Info.Image = ((System.Drawing.Image)(resources.GetObject("Info.Image")));
			this.Info.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
			this.Info.Location = new System.Drawing.Point(312, 8);
			this.Info.Name = "Info";
			this.Info.Size = new System.Drawing.Size(75, 75);
			this.Info.TabIndex = 9;
			this.Info.Text = "Info";
			this.Info.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			this.Info.Click += new System.EventHandler(this.Info_Click);
			// 
			// Form2
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.SlateGray;
			this.ClientSize = new System.Drawing.Size(568, 549);
			this.Controls.Add(this.Info);
			this.Controls.Add(this.RecordButton);
			this.Controls.Add(this.SaveButton);
			this.Controls.Add(this.Clear);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.panel1);
			this.Name = "Form2";
			this.Text = "Record Presentation";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.ResumeLayout(false);

		}
		#endregion
		private void panel1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) 
		{
			if(!isRecording) return;
			// Update the mouse path with the mouse information
			Point mouseDownLocation = new Point(e.X, e.Y);

			string eventString = null;
			switch (e.Button) 
			{
				case MouseButtons.Left:
					eventString = "L";
					break;
				case MouseButtons.Right:
					eventString = "R";
					break;
				case MouseButtons.Middle:
					eventString = "M";
					break;
				case MouseButtons.XButton1:
					eventString = "X1";
					break;
				case MouseButtons.XButton2:
					eventString = "X2";
					break;
				case MouseButtons.None:
				default:
					break;
			}

			if(eventString == "L")
			{
				isDrawing = true;
				mousepath.Add(new ArrayList());
				vectorpath.Add(new ArrayList());
				((ArrayList)mousepath[ mousepath.Count - 1]).Add(mouseDownLocation);
				((ArrayList)vectorpath[ vectorpath.Count - 1]).Add(mouseDownLocation);

				vectortime.Add(new ArrayList());
				((ArrayList)vectortime[ vectortime.Count - 1]).Add(DateTime.Now.Ticks - starttime.Ticks);
			}
			panel1.Focus();
			panel1.Invalidate();
		}

		private void panel1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if(!isRecording) return;
			// Update the mouse path that is drawn onto the Panel.
			Point mouseDownLocation = new Point(e.X, e.Y);
			

			if(isDrawing)
			{
				counter++;

				ArrayList currentMousePath = ((ArrayList)mousepath[mousepath.Count - 1]);
				currentMousePath.Add(mouseDownLocation);
				System.Drawing.Graphics gr1 = this.panel1.CreateGraphics();
				gr1.DrawLine(System.Drawing.Pens.DarkBlue, ((Point)currentMousePath[currentMousePath.Count -2]),((Point)currentMousePath[currentMousePath.Count -1]));
				gr1.Dispose();

				if(counter == (rate*3))
				{
					ArrayList currentVectorPath = ((ArrayList)vectorpath[vectorpath.Count - 1]);
					int currentcount = currentMousePath.Count;
					currentVectorPath.Add( currentMousePath[ currentcount - (1 + rate*2)]);
					currentVectorPath.Add( currentMousePath[ currentcount - (1 + rate*1)]);
					currentVectorPath.Add( currentMousePath[ currentcount - (1)]);

					ArrayList currentVectorTime = ((ArrayList)vectortime[vectortime.Count - 1]);
					currentVectorTime.Add(DateTime.Now.Ticks - starttime.Ticks);
					
					System.Drawing.Graphics gr2 = this.panel2.CreateGraphics();
					gr2.DrawBezier(System.Drawing.Pens.DarkBlue, ((Point)currentVectorPath[currentVectorPath.Count - 4]), ((Point)currentVectorPath[currentVectorPath.Count - 3]), ((Point)currentVectorPath[currentVectorPath.Count - 2]), ((Point)currentVectorPath[currentVectorPath.Count - 1]));
					gr2.Dispose();
					counter = 0;
				}
			}
		}

		private void panel1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e) 
		{
			if(!isRecording) return;
			if(e.Button ==  MouseButtons.Left)
			{
				if(isDrawing)
				{
					Point mouseDownLocation = new Point(e.X, e.Y);

					ArrayList currentMousePath = ((ArrayList)mousepath[mousepath.Count - 1]);
					currentMousePath.Add(mouseDownLocation);
					System.Drawing.Graphics gr1 = this.panel1.CreateGraphics();
					gr1.DrawLine(System.Drawing.Pens.DarkBlue, ((Point)currentMousePath[currentMousePath.Count -2]),((Point)currentMousePath[currentMousePath.Count -1]));
					gr1.Dispose();

					ArrayList currentVectorPath = ((ArrayList)vectorpath[vectorpath.Count - 1]);
					int currentcount = currentMousePath.Count;
					currentVectorPath.Add( currentVectorPath[ currentVectorPath.Count -1]);
					currentVectorPath.Add( mouseDownLocation);
					currentVectorPath.Add( mouseDownLocation);

					ArrayList currentVectorTime = ((ArrayList)vectortime[vectortime.Count - 1]);
					currentVectorTime.Add(DateTime.Now.Ticks - starttime.Ticks);
					
					System.Drawing.Graphics gr2 = this.panel2.CreateGraphics();
					gr2.DrawBezier(System.Drawing.Pens.DarkBlue, ((Point)currentVectorPath[currentVectorPath.Count - 4]), ((Point)currentVectorPath[currentVectorPath.Count - 3]), ((Point)currentVectorPath[currentVectorPath.Count - 2]), ((Point)currentVectorPath[currentVectorPath.Count - 1]));
					gr2.Dispose();

		
					counter = 0;
				}
				isDrawing = false;
				panel1.Invalidate();
				panel2.Invalidate();
			}
		}

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e) 
		{    
			if(!isRecording) return;
			// Perform the painting of the Panel.

			for(int i =lastClearMouse; i < mousepath.Count; i++)
			{
				for(int j = 1; j <((ArrayList)mousepath[i]).Count; j++)
				{
					e.Graphics.DrawLine(myPen, ((Point)((ArrayList)mousepath[i])[j-1]), ((Point)((ArrayList)mousepath[i])[j]));
				}
			}
		}

		private void Form1_Resize(object sender, System.EventArgs e)
		{
			this.panel1.Left = 0;
			this.panel1.Width = this.Width / 2 - 2;
			this.panel2.Left = this.Width / 2;
			this.panel2.Width = this.Width/2 - 2;
		}

		private void panel2_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if(!isRecording) return;
			for(int i =lastClearVector; i < vectorpath.Count; i++)
			{
				for(int j = 3; j < ((ArrayList)vectorpath[i]).Count; j=j+3)
				{
					e.Graphics.DrawBezier(myPen, ((Point)((ArrayList)vectorpath[i])[j-3]), ((Point)((ArrayList)vectorpath[i])[j-2]), ((Point)((ArrayList)vectorpath[i])[j-1]), ((Point)((ArrayList)vectorpath[i])[j]));
				}
			}
		}

		private void Clear_Click(object sender, System.EventArgs e)
		{
			if(!isRecording) return;
			mousepath.Add(cleararray);
			vectorpath.Add(cleararray);

			vectortime.Add(new ArrayList());
			ArrayList currentVectorTime = ((ArrayList)vectortime[vectortime.Count - 1]);
			currentVectorTime.Add(DateTime.Now.Ticks - starttime.Ticks);

			lastClearMouse = mousepath.Count;
			lastClearVector = vectorpath.Count;


			panel1.Invalidate();
			panel2.Invalidate();
		}

		private void SaveButton_Click(object sender, System.EventArgs e)
		{
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				ArrayList infolist = new ArrayList();
				infolist.Add(myInfo.Title.Text);
				infolist.Add(myInfo.Author.Text);
				infolist.Add(myInfo.Course.Text);
				infolist.Add(myInfo.Description.Text);

				ArrayList masterlist = new ArrayList();
				masterlist.Add(vectorpath);
				masterlist.Add(vectortime);
				masterlist.Add(infolist);

				System.IO.Stream myFileStream = saveFileDialog1.OpenFile();
				BinaryFormatter serializer = new BinaryFormatter();
				serializer.Serialize(myFileStream, masterlist);
				myFileStream.Close();

			}
		}

		private void Info_Click(object sender, System.EventArgs e)
		{
			myInfo.ShowDialog();
		}

		private void RecordButton_Click(object sender, System.EventArgs e)
		{
			if(!isRecording)
			{
				isRecording = true;
				starttime = DateTime.Now;
			}
		}
	}
}
